package massim.agent.framework;

/*
 * An abstract class serving as a message content holder.
 * 
 */
public abstract class MessageContent implements Comparable<MessageContent> {

    long timestamp = 0;

    // you should make a deep copy of this object
    @Override
    public abstract MessageContent clone();

    public long getTimestamp() {
        // if zero is returned, it means the timestamp was never initialized!
        return timestamp;
    }

    public void setTimestamp(long timestamp) {
        this.timestamp = timestamp;
    }

    @Override
    public int compareTo(MessageContent o) {
        return (int) (o.getTimestamp() - this.timestamp);
    }
}
